=== debian/changelog ===
ableton-link (3.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.2+dfsg
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 15 Jul 2024 23:53:55 +0200
