=== debian/control ===
Source: ableton-link
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 catch2 (>= 3~) <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 libasio-dev,
 libjack-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.ableton.com/en/link/
Vcs-Git: https://salsa.debian.org/multimedia-team/ableton-link.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ableton-link

Package: ableton-link-dev
Architecture: all
Multi-Arch: foreign
Depends:
 libasio-dev,
 ${misc:Depends},
Description: synchronizes musical applications on multiple devices - development
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 Ableton Link is implemented as a header-only C++-library.
 This package contains the development files.

Package: ableton-link-utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: synchronizes musical applications on multiple devices - cmdline utils
 Ableton Link, a technology that synchronizes musical beat, tempo, and phase
 across multiple applications running on one or more devices. Applications on
 devices connected to a local network discover each other automatically and form
 a musical session in which each participant can perform independently: anyone
 can start or stop while still staying in time. Anyone can change the tempo, the
 others will follow. Anyone can join or leave without disrupting the session.
 .
 This package contains cmdline utilities to check synchronisation.
