=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_FLAGS = -DLINK_BUILD_JACK=ON

ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
CONFIGURE_FLAGS += -DLINK_BUILD_TESTS=OFF
else
CONFIGURE_FLAGS += -DLINK_BUILD_TESTS=ON
endif


# workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=81358
ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mipsel powerpc riscv64 sh4))
export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(CONFIGURE_FLAGS)

execute_after_dh_install-indep:
	find $(CURDIR)/debian/ableton-link-dev/usr/share -name "*.cmake" -exec \
		sed -e 's|$${CMAKE_CURRENT_LIST_DIR}/include|/usr/include|g' -i {} +

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
