=== debian/tests/control ===
Tests: build-examples-cmake
Depends:
 ableton-link-dev,
 build-essential,
 cmake,
 portaudio19-dev,
Restrictions: allow-stderr
